# Django Courses

A smart Django application to offer MOOC courses functionality.

## Quickstart

Install Django Courses:
```bash
pip install git+https://git.hacklab.com.br/hackmooc/django-courses.git@master#egg=django-courses
```

Add it to your `INSTALLED_APPS`:
```python
INSTALLED_APPS = (
    ...
    'courses.apps.CoursesConfig',
    ...
)
```

Add Django Courses's URL patterns:
```python
from courses import urls as courses_urls

urlpatterns = [
    ...
    url(r'^', include(courses_urls)),
    ...
]
```

## Activity streams
Its possible to log `user-access` by sending a POST request to `/api/stats/user-access/`. Payload example:
```json
{
  "area": "dashboard"
}
```
Note: available areas must be created via Django Admin previously: `<HOST>/django/admin/stats/accessiblearea/`


To log generic activities, send a POST request to `/api/user-actions/`.
```json
{
  "verb": "created comment",
  "action_object_id": 7,         # optional
  "action_object_type": "Topic", # optional
  "target_id": 26,               # optional
  "target_type": "Forum"         # optional
}
```
Note: any model used as object or target must have been previously registered at `django-courses/courses/stats/apps.py`
