from django.contrib import admin

from .models import (
    CourseCertification,
    CertificateTemplate,
    CertificationProcess,
    Evaluation,
)

@admin.register(CertificateTemplate)
class CertificateTemplateAdmin(admin.ModelAdmin):
    list_display = ('course', 'document_type', 'workspace')


@admin.register(CourseCertification)
class CourseCertificationAdmin(admin.ModelAdmin):
    list_display = ('course_student', 'type', 'link_hash', 'created_date', 'modified_date')
    autocomplete_fields = (
        'course_student',
    )
    search_fields = (
        'link_hash',
        'course_student__user__name',
        'course_student__user__email',
        'course_student__user__username',
    )

admin.site.register(CertificationProcess)
admin.site.register(Evaluation)
