# Generated by Django 2.1.7 on 2019-03-07 23:22

import courses.utils
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('courses', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='CertificateTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('role', models.CharField(blank=True, max_length=128, null=True, verbose_name='Role')),
                ('name', models.CharField(blank=True, max_length=255, null=True, verbose_name='Signature Name')),
                ('cert_logo', models.ImageField(blank=True, null=True, upload_to=courses.utils.HashName('logo', 'organization_name'), verbose_name='Logo')),
                ('base_logo', models.ImageField(blank=True, null=True, upload_to=courses.utils.HashName('base_logo', 'organization_name'), verbose_name='Logo')),
                ('signature', models.ImageField(blank=True, null=True, upload_to=courses.utils.HashName('signature', 'organization_name'), verbose_name='Signature')),
                ('organization_name', models.CharField(blank=True, max_length=255, null=True, verbose_name='Name')),
                ('course', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='courses.Course', verbose_name='Course')),
            ],
            options={
                'verbose_name': 'Certificate Template',
            },
        ),
        migrations.CreateModel(
            name='CertificationProcess',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('comments', models.CharField(blank=True, max_length=255, null=True, verbose_name='Comments')),
                ('created_date', models.DateTimeField(auto_now_add=True, verbose_name='Created')),
                ('evaluation_grade', models.IntegerField(blank=True, null=True, verbose_name='Evaluation grade')),
                ('approved', models.BooleanField(default=False, verbose_name='Approved')),
                ('no_show', models.BooleanField(default=False, verbose_name='No show')),
                ('active', models.BooleanField(default=True, verbose_name='Active')),
            ],
            options={
                'verbose_name': 'Certification Process',
            },
        ),
        migrations.CreateModel(
            name='CourseCertification',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(choices=[('receipt', 'Receipt'), ('certificate', 'Certificate')], max_length=127, verbose_name='Certificate Type')),
                ('created_date', models.DateTimeField(auto_now_add=True, verbose_name='Created')),
                ('modified_date', models.DateTimeField(auto_now=True, verbose_name='Last modified')),
                ('is_valid', models.BooleanField(default=False, verbose_name='Certificate is valid')),
                ('course_workload', models.TextField(blank=True, verbose_name='Workload')),
                ('course_total_units', models.IntegerField(blank=True, verbose_name='Total units')),
                ('link_hash', models.CharField(max_length=255, unique=True, verbose_name='Hash')),
                ('course_student', models.OneToOneField(on_delete=django.db.models.deletion.PROTECT, related_name='certificate', to='courses.CourseStudent', verbose_name='Enrollment')),
            ],
            options={
                'verbose_name': 'Certificate',
            },
        ),
        migrations.CreateModel(
            name='Evaluation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('min_grade', models.IntegerField(blank=True, verbose_name='Evaluation grade needed')),
                ('date', models.DateTimeField(blank=True, verbose_name='Evaluation date')),
                ('results_date', models.DateTimeField(blank=True, verbose_name='Evaluation results date')),
                ('instructions', models.CharField(max_length=255, verbose_name='Comments')),
                ('klass', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='evaluations', to='courses.Class', verbose_name='Class')),
            ],
            options={
                'verbose_name': 'Evaluation',
            },
        ),
        migrations.AddField(
            model_name='certificationprocess',
            name='course_certification',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='processes', to='certification.CourseCertification', verbose_name='Certificate'),
        ),
        migrations.AddField(
            model_name='certificationprocess',
            name='evaluation',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='processes', to='certification.Evaluation', verbose_name='Evaluation'),
        ),
        migrations.AddField(
            model_name='certificationprocess',
            name='klass',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='processes', to='courses.Class', verbose_name='Class'),
        ),
        migrations.AddField(
            model_name='certificationprocess',
            name='student',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='processes', to=settings.AUTH_USER_MODEL, verbose_name='Student'),
        ),
    ]
