from django.db.models.signals import post_save

from courses.models import CourseStudent
from courses.certification.models import CourseCertification


@receiver(m2m_changed, sender=Class.students.through)
def remove_duplicate_classes(sender, instance, action, reverse, model, pk_set, **kwargs):
    """Clean the same student in twice classes."""
    # add student to default_class everytime that m2m cleans
    if action == 'pre_clear':
        default_class = instance.course.default_class
        for student in instance.students.all():
            student.classes.add(default_class)

    # garantee that student has been subscribe in only one class
    if action == 'post_add':
        try:
            for student in instance.students.all():
                classes = student.classes.filter(course=instance.course).exclude(id=instance.id)
                for classe in classes:
                    student.classes.remove(classe)

        # garantee that this block executes only when instance == Class.
        except AttributeError:
            pass
