from rest_framework import permissions


class IsClassroomAssistantOrCoordinatorOrReadOnly(permissions.BasePermission):
    """
    Check if a user can send messages to students enrolled in a course
    """
    def has_object_permission(self, request, view, obj):
        # Read permissions are allowed to any request,
        # so we'll always allow GET, HEAD or OPTIONS requests.
        if request.method in permissions.SAFE_METHODS:
            return True
        elif request.user and request.user.is_superuser:
            return True    
        elif request.user and (request.user in obj.assistants.all() or request.user in obj.coordinators.all()):
            return True
