from rest_framework import serializers

from courses.course_material.models import CourseMaterial, File


class FilesSerializer(serializers.ModelSerializer):

    class Meta:
        model = File
        fields = '__all__'


class CourseMaterialSerializer(serializers.ModelSerializer):
    files = FilesSerializer(many=True, required=False, read_only=True)

    class Meta:
        model = CourseMaterial
        fields = '__all__'


class CourseMaterialImportExportSerializer(serializers.ModelSerializer):
    files = FilesSerializer(many=True, required=False)

    class Meta:
        model = CourseMaterial
        fields = ('text', 'files',)
