from django.db import models
from django.utils.translation import ugettext_lazy as _


class AccessibleArea(models.Model):
    name = models.CharField(
        _('Name'),
        max_length=255,
    )
    slug = models.SlugField(
        _('Slug'),
        max_length=255,
        unique=True,
    )
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.name
