from django.db import models
from django.utils.translation import ugettext_lazy as _

class Video(models.Model):
    name = models.CharField(
        max_length=255,
    )
    youtube_id = models.CharField(
        max_length=100,
    )

    class Meta:
        verbose_name = _('Video')
        verbose_name_plural = _('Videos')

    def __unicode__(self):
        if self.unit.first():
            unit = self.unit.first()
            if unit.lesson:
                return u'Aula: {0} | Unidade: {1} | id youtube: {2}'.format(
                    unit.lesson, unit, self.youtube_id)
        return self.youtube_id
